declare const version: any;
import { IIPPConfig, IConfig } from './Config';
import { IApiService } from './Api';
import { IStorageService } from './Storage';
import { IClassy } from './Classy';
import { IUtils } from './Utils';
import { IHelpers } from './Helpers';
import { IAuthService } from './Auth';
import { ICryptoService } from './Crypto';
import { IPageMain, Page, IPageService } from './Page/Page';
import { Clipboard, IClipboard } from './Clipboard';
import { ITracking } from './Tracking';
import { PermissionRange, IPagePermissionRange, IPageRangeRights } from './Page/Range';
import { IPdf, Pdf } from './Pdf';
import { IGrid, Grid } from './Grid4/Grid';
import { IFunctions, IFunctionsVar, Functions } from './Functions';
import { IPageContent } from './Page/Content';
import { IKeysService } from './Keys';
import { IActionsButton, Button } from './Actions/Buttons';
import { IActionsChart, Chart } from './Actions/Charts';
import { ITask, Task, ITaskActionSet, ITaskActionSetAction, ITaskActionSetActionShare, ITaskActionSetActionNotification, ITaskActionSetActionShareComponent, ITaskActionSetActionData, TaskActions, TaskAction, ShareTaskAction, DataTaskAction, NotificationTaskAction, ComponentTaskAction } from './Actions/Tasks';
import { IActionsStyle, IActionsStyleCondition, Style, StyleCondition } from './Actions/Styles';
import { Folder } from './Folder';
import { IUsage } from './Usage';
import { IBilling } from './Billing';
import { IOrganization } from './Organization';
import { IPageSchema, PageSchema } from './Page/Schema';
export interface ICreate {
    version: string;
    config: any;
    api: IApiService;
    auth: IAuthService;
    crypto: ICryptoService;
    tracking: ITracking;
    helpers: IHelpers;
    storage: IStorageService;
    usage: IUsage;
    organization: IOrganization;
    utils: IUtils;
    keys: IKeysService;
    billing: IBilling;
    Grid: new (id: string, options?: any) => IGrid;
    Page: new (pageId: number | string, folderId: number | string, uuid?: string) => IPageMain;
    PermissionRange: new (name: string, rowStart: number, rowEnd: number, colStart: number, colEnd: number, permissions?: IPageRangeRights) => IPagePermissionRange;
    Clipboard: new (element?: any, doc?: boolean) => IClipboard;
    Pdf: new (container: string) => IPdf;
    Functions: new (content?: IPageContent, vars?: IFunctionsVar) => IFunctions;
    Button: new (data?: any) => IActionsButton;
    Chart: new (data?: any) => IActionsChart;
    Task: new (data?: any) => ITask;
    TaskActions: new (data?: any) => ITaskActionSet;
    TaskAction: new (data?: any) => ITaskActionSetAction;
    DataTaskAction: new (data?: any) => ITaskActionSetActionData;
    ShareTaskAction: new (data?: any) => ITaskActionSetActionShare;
    NotificationTaskAction: new (data?: any) => ITaskActionSetActionNotification;
    ComponentTaskAction: new (data?: any) => ITaskActionSetActionShareComponent;
    Style: new (data?: any) => IActionsStyle;
    StyleCondition: new (data?: any) => IActionsStyleCondition;
    Folder: new () => Folder;
    PageSchema: new (data?: any) => IPageSchema;
}
declare const ScriptLoader: (url: string) => void;
declare const config: IConfig;
declare const storage: IStorageService;
declare const api: IApiService;
declare const crypto: ICryptoService;
declare const auth: IAuthService;
declare const helpers: IHelpers;
declare const utils: IUtils;
declare const tracking: ITracking;
declare const usage: IUsage;
declare const organization: IOrganization;
declare const keys: IKeysService;
declare const billing: IBilling;
export declare class Create implements ICreate {
    settings: IIPPConfig;
    version: any;
    config: IConfig;
    storage: IStorageService;
    classy: IClassy;
    helpers: IHelpers;
    utils: IUtils;
    api: IApiService;
    auth: IAuthService;
    crypto: ICryptoService;
    tracking: ITracking;
    usage: IUsage;
    organization: IOrganization;
    keys: IKeysService;
    billing: IBilling;
    Grid: new (id: string, options?: any) => IGrid;
    PermissionRange: new (name: string, rowStart: number, rowEnd: number, colStart: number, colEnd: number, permissions?: IPageRangeRights) => IPagePermissionRange;
    Page: IPageService;
    Clipboard: new (element?: any, doc?: boolean) => IClipboard;
    Pdf: new (container: string) => IPdf;
    Functions: new (content?: IPageContent, vars?: IFunctionsVar) => IFunctions;
    Button: new (data?: any) => IActionsButton;
    Chart: new (data?: any) => IActionsChart;
    Task: new (data?: any) => ITask;
    TaskActions: new (data?: any) => ITaskActionSet;
    TaskAction: new (data?: any) => ITaskActionSetAction;
    DataTaskAction: new (data?: any) => ITaskActionSetActionData;
    ShareTaskAction: new (data?: any) => ITaskActionSetActionShare;
    NotificationTaskAction: new (data?: any) => ITaskActionSetActionNotification;
    ComponentTaskAction: new (data?: any) => ITaskActionSetActionShareComponent;
    Style: new (data?: any) => IActionsStyle;
    StyleCondition: new (data?: any) => IActionsStyleCondition;
    Folder: new () => Folder;
    PageSchema: new (data?: any) => IPageSchema;
    constructor(settings: IIPPConfig);
}
export { version, config, storage, api, crypto, auth, helpers, utils, tracking, usage, organization, keys, billing, Page, ScriptLoader, Grid, Pdf, Functions, Clipboard, PermissionRange, Button, Chart, Task, TaskActions, TaskAction, DataTaskAction, ShareTaskAction, NotificationTaskAction, ComponentTaskAction, Style, StyleCondition, Folder, PageSchema };
export interface IPushPull {
    version: string;
    config: IConfig;
    storage: IStorageService;
    api: IApiService;
    crypto: ICryptoService;
    auth: IAuthService;
    helpers: IHelpers;
    utils: IUtils;
    tracking: ITracking;
    usage: IUsage;
    organization: IOrganization;
    keys: IKeysService;
    billing: IBilling;
    Create: new (settings: IIPPConfig) => ICreate;
    Page: IPageService;
    ScriptLoader: any;
    Grid: new (id: string, options?: any) => IGrid;
    Functions: new (content?: IPageContent, vars?: IFunctionsVar) => IFunctions;
    Clipboard: new (element?: any, doc?: boolean) => IClipboard;
    PermissionRange: new (name: string, rowStart: number, rowEnd: number, colStart: number, colEnd: number, permissions?: IPageRangeRights) => IPagePermissionRange;
    Pdf: new (container: string) => IPdf;
    Button: new (data?: any) => IActionsButton;
    Chart: new (data?: any) => IActionsChart;
    Task: new (data?: any) => ITask;
    TaskActions: new (data?: any) => ITaskActionSet;
    TaskAction: new (data?: any) => ITaskActionSetAction;
    DataTaskAction: new (data?: any) => ITaskActionSetActionData;
    ShareTaskAction: new (data?: any) => ITaskActionSetActionShare;
    NotificationTaskAction: new (data?: any) => ITaskActionSetActionNotification;
    ComponentTaskAction: new (data?: any) => ITaskActionSetActionShareComponent;
    Style: new (data?: any) => IActionsStyle;
    StyleCondition: new (data?: any) => IActionsStyleCondition;
    Folder: new () => Folder;
    PageSchema: new (data?: any) => IPageSchema;
}
declare let ipushpull: IPushPull;
export default ipushpull;
